exercise_04_19: exercise_04_19.o | .gitignore
	g++ $^ -o $@

exercise_04_19.ii: exercise_04_19.cpp       
	g++ -E $^ -o $@
	      
exercise_04_19.s: exercise_04_19.ii		
	g++ -S $^ -o $@

exercise_04_19.o: exercise_04_19.s
	g++ -c $^ -o $@

.gitignore:
	echo "exercise_04-19" > $@

clean:
	rm *.ii *.s *.o *.out exercise_04_19 .gitignore

test1: exercise_04_19
	./exercise_04_19 < test1.in > test1.out && echo "Test 1 is executing..."
		diff test1.out test1.expected && echo PASSED || echo FAILED

test2: exercise_04_19
	./exercise_04_19 < test2.in > test2.out && echo "Test 2 is executing..."
	diff test2.out test2.expected && echo PASSED || echo FAILED

.PRECIOUS: exercise_04_19.ii exercise_04_19.s
.SECONDARY: exercise_04_19.ii exercise_04_19.s

